freeslot("sfx_vsknux", "sfx_s3ksup",
"sfx_ssonic", "sfx_ssonsc",
"sfx_sdswbf", "sfx_noelsa",
"sfx_chaotx",
"sfx_papua1",
"sfx_manias",
"sfx_slaris",
"sfx_doomsd",
"sfx_bigarm",
"sfx_vmknux",
"sfx_metmad",
"sfx_livlrn",
"sfx_wrapbl")

local superTable = {
knuckles = {"vsknux", "s3ksup"},
sonic = {"ssonic", "ssonsc", "s3ksup"},
tails = {"s3ksup"},
metalsonic = {"sdswbf", "noelsa"},
vector = {"chaotx"},
espio = {"chaotx"},
charmy = {"chaotx"},
flicky = {"pupaa1"},
vexermighty = {"manias"},
mighty = {"manias"},
ray = {"manias"},
silver = {"slaris"},
mechasonic = {"doomsd"},
eggman = {"bigarm"},
metalknuckles = {"vmknux"},
deton = {"metmad"},
shadow = {"livlrn"},
blaze = {"wrapbl"},
snolf = {"ssonic", "ssonsc", "s3ksup"}}

local specialThemes = {
vsalt = true,
vsboss = true,
vsbrak = true,
vsfang = true,
vsmetl = true,
bcz1 = true,
mp_mrz = true}

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.valid)
			if not superTable[player.mo.skin]
				superTable[player.mo.skin] = "_super"
			end
			if (not player.mo.rtheme) or ((player.mo.rthemeskin) and (player.mo.rthemeskin ~= player.mo.skin)) then
				player.mo.rtheme = superTable[player.mo.skin][P_RandomRange(1, #(superTable[player.mo.skin]))]
				player.mo.rthemeskin = player.mo.skin
			end
			if player.powers[pw_super] then
				local theme = player.stheme or player.mo.rtheme or "_super"
				if ((not player.powers[pw_extralife]) and (not player.exiting)) and ((S_MusicName() == theme) or (not specialThemes[S_MusicName()]))
					S_ChangeMusic(theme,true,player,0,player.supMusPosition)
					player.supMusPosition = S_GetMusicPosition()
				elseif (not specialThemes[S_MusicName()])
					P_RestoreMusic(player)
				end
			else
				player.supMusPosition = 0
			end
		end
	end
end)

COM_AddCommand("setsupertheme", function(player, ...)
	local arg = {...}
	local skin, variant, track
	if #arg == 0 then
		player.stheme = nil
		CONS_Printf(player, "Setting super theme to default.\nFunction usage:\nsetsupertheme\nsetsupertheme [skin]\nsetsupertheme [variant]\nsetsupertheme [skin] [variant]\nsetsupertheme default\nIf called without any parameters, sets super theme to skin default and displays this.\nIf called with skin parameter, sets super theme to that skin's variant 1; entering a variant parameter sets super theme to that skin's variant theme.\nIf called with the parameter 'default', sets super theme to SRB2 default.")
		return
	elseif #arg == 1 then
		if arg[1] == "default" then
			player.stheme = "_super"
			CONS_Printf(player, "Setting super theme to SRB2 default.")
			return
		elseif superTable[arg[1]] then
			player.stheme = superTable[arg[1]][1]
			CONS_Printf(player, "Setting super theme to \"" + player.stheme + "\"; variant 1 of " + #(superTable[arg[1]]) + " of the super theme of " + arg[1] + ".")
			return
		elseif tonumber(arg[1]) then
			if not superTable[player.realmo.skin] then
				CONS_Printf(player, "Error: No unique super themes exist for " + player.realmo.skin + ". Setting super theme to default.")
			end
			player.stheme = superTable[player.realmo.skin][tonumber(arg[1])]
			if not player.stheme then
				CONS_Printf(player, "Error: " + player.realmo.skin + " has only " + #(superTable[player.realmo.skin]) + " super theme variants; setting theme to variant 1.")
				player.stheme = superTable[player.realmo.skin][1]
				return
			end
			CONS_Printf(player, "Setting super theme to \"" + player.stheme + "\"; variant " + arg[1] + " of " + #(superTable[player.realmo.skin]) + " of the super theme of " + player.realmo.skin + ".")
			return
		else
			player.stheme = nil
			CONS_Printf(player, "Error: Input was neither a skin there exist super themes for, a number or default. Setting super theme to default.")
			return
		end
	elseif #arg == 2 then
		if not superTable[arg[1]] then
			player.sthene = nil
			CONS_Printf(player, "Error: No unique super themes exist for " + arg[1] + ". Setting super theme to default.")
			return
		elseif not superTable[arg[1]][tonumber(arg[2])] then
			player.stheme = superTable[arg[1]][1]
			CONS_Printf(player, "Error: " + arg[1] + " has only " + #(superTable[arg[1]]) + " super theme variants; setting theme to variant 1.")
			return
		else
			player.stheme = superTable[arg[1]][tonumber(arg[2])]
			CONS_Printf(player, "Setting super theme to \"" + player.stheme + "\"; variant " + arg[2] + " of " + #(superTable[arg[1]]) + " of the super theme of " + arg[1] + ".")
			return
		end
	end
	CONS_Printf(player, "Error: Too many inputs.")
end)